// ==============================================================
// RTL generated by Vivado(TM) HLS - High-Level Synthesis from C, C++ and SystemC
// Version: 2014.1
// Copyright (C) 2014 Xilinx Inc. All rights reserved.
// 
// ===========================================================

`timescale 1 ns / 1 ps 

(* CORE_GENERATION_INFO="deinterleave_v2,hls_ip_2014_1,{HLS_INPUT_TYPE=cxx,HLS_INPUT_FLOAT=0,HLS_INPUT_FIXED=1,HLS_INPUT_PART=xc6slx9tqg144-2,HLS_INPUT_CLOCK=10.000000,HLS_INPUT_ARCH=others,HLS_SYN_CLOCK=0.000000,HLS_SYN_LAT=-1,HLS_SYN_TPT=none,HLS_SYN_MEM=0,HLS_SYN_DSP=0,HLS_SYN_FF=0,HLS_SYN_LUT=0}" *)

module deinterleave_v2 (
        ap_clk,
        ap_rst_n,
        input_data,
        input_empty_n,
        input_read,
        output_data,
        output_full,
        output_write
);


parameter    STATE_INIT = 2'b00;
parameter    STATE_SAMP1 = 2'b1;
parameter    STATE_SAMP2 = 2'b10;

input   ap_clk;
input   ap_rst_n;
input  [47:0] input_data;
input   input_empty_n;
output   input_read;
output  [17:0] output_data;
input   output_full;
output   output_write;

reg input_read;
reg[17:0] output_data;
reg output_write;
reg   [17:0] input_half_2;
reg   [1:0] state_reg = 2'b00;
reg    flow_is_busy;
wire   [17:0] input_half_1;
reg   [1:0] state_new;




/// the current state (state_reg) of the state machine. ///
always @ (posedge ap_clk)
begin : ap_ret_state_reg
    if (ap_rst_n == 1'b0) begin
        state_reg <= STATE_INIT;
    end else begin
        state_reg <= state_new;
    end
end

/// assign process. ///
always @(posedge ap_clk)
begin
    if (((STATE_SAMP1 == state_reg) & ~flow_is_busy)) begin
        input_half_2 <= {{input_data[41 : 24]}};
    end
end

/// input_read assign process. ///
always @ (state_reg or flow_is_busy)
begin
    if (((STATE_SAMP1 == state_reg) & ~flow_is_busy)) begin
        input_read = 1'b1;
    end else begin
        input_read = 1'b0;
    end
end

/// output_data assign process. ///
always @ (output_full or input_half_2 or state_reg or flow_is_busy or input_half_1)
begin
    if (((STATE_SAMP2 == state_reg) & ~(output_full == 1'b1))) begin
        output_data = input_half_2;
    end else if (((STATE_SAMP1 == state_reg) & ~flow_is_busy)) begin
        output_data = input_half_1;
    end else begin
        output_data = 'bx;
    end
end

/// output_write assign process. ///
always @ (output_full or state_reg or flow_is_busy)
begin
    if ((((STATE_SAMP1 == state_reg) & ~flow_is_busy) | ((STATE_SAMP2 == state_reg) & ~(output_full == 1'b1)))) begin
        output_write = 1'b1;
    end else begin
        output_write = 1'b0;
    end
end
always @ (output_full or state_reg or flow_is_busy)
begin
    case (state_reg)
        STATE_INIT : 
            state_new = STATE_SAMP1;
        STATE_SAMP1 : 
            if (~flow_is_busy) begin
                state_new = STATE_SAMP2;
            end else begin
                state_new = STATE_SAMP1;
            end
        STATE_SAMP2 : 
            if (~(output_full == 1'b1)) begin
                state_new = STATE_SAMP1;
            end else begin
                state_new = STATE_SAMP2;
            end
        default : 
            state_new = 'bx;
    endcase
end

/// flow_is_busy assign process. ///
always @ (input_empty_n or output_full)
begin
    flow_is_busy = ((input_empty_n == 1'b0) | ~(output_full == 1'b0));
end
assign input_half_1 = input_data[17:0];


endmodule //deinterleave_v2

