// ==============================================================
// RTL generated by Vivado(TM) HLS - High-Level Synthesis from C, C++ and SystemC
// Version: 2014.1
// Copyright (C) 2014 Xilinx Inc. All rights reserved.
// 
// ===========================================================

`timescale 1 ns / 1 ps 

(* CORE_GENERATION_INFO="interleave8to32,hls_ip_2014_1,{HLS_INPUT_TYPE=cxx,HLS_INPUT_FLOAT=0,HLS_INPUT_FIXED=1,HLS_INPUT_PART=xc6slx9tqg144-2,HLS_INPUT_CLOCK=10.000000,HLS_INPUT_ARCH=others,HLS_SYN_CLOCK=0.000000,HLS_SYN_LAT=-1,HLS_SYN_TPT=none,HLS_SYN_MEM=0,HLS_SYN_DSP=0,HLS_SYN_FF=0,HLS_SYN_LUT=0}" *)

module interleave8to32_v2 (
        ap_clk,
        ap_rst_n,
        input_data,
        input_empty_n,
        input_read,
        output_data,
        output_full_n,
        output_write
);

parameter    STATE_INIT = 3'b000;
parameter    STATE_BYTE0 = 3'b1;
parameter    STATE_BYTE1 = 3'b10;
parameter    STATE_BYTE2 = 3'b11;
parameter    STATE_BYTE3 = 3'b100;

input   ap_clk;
input   ap_rst_n;
input  [7:0] input_data;
input   input_empty_n;
output   input_read;
output  [31:0] output_data;
input   output_full_n;
output   output_write;


reg input_read;
reg output_write;

reg   [7:0] buff_byte0;
reg   [7:0] buff_byte1;
reg   [7:0] buff_byte2;
reg   [2:0] state_reg = 3'b000;
reg   [2:0] state_new;
reg   flow_is_busy;
//wire  [2:0] state_after_init;




/// the current state (state_reg) of the state machine. ///
always @ (posedge ap_clk)
begin : ap_ret_state_reg
    if (ap_rst_n == 1'b0) begin
        state_reg <= STATE_INIT;
    end else begin
        state_reg <= state_new;
    end
end

/// assign process. ///
always @(posedge ap_clk)
begin
    if ((~(input_empty_n == 1'b0) & (STATE_BYTE1 == state_reg))) begin
        buff_byte1 <= input_data;
    end
end

/// assign process. ///
always @(posedge ap_clk)
begin
    if ((~(input_empty_n == 1'b0) & (STATE_BYTE2 == state_reg))) begin
        buff_byte2 <= input_data;
    end
end

/// assign process. ///
always @(posedge ap_clk)
begin
    if (((STATE_BYTE0 == state_reg) & ~(input_empty_n == 1'b0))) begin
        buff_byte0 <= input_data;
    end
end

/// input_read assign process. ///
always @ (input_empty_n or state_reg or flow_is_busy)
begin
    if ((((STATE_BYTE0 == state_reg) & ~(input_empty_n == 1'b0)) | (~(input_empty_n == 1'b0) & (STATE_BYTE1 == state_reg)) | (~(input_empty_n == 1'b0) & (STATE_BYTE2 == state_reg)) | ((STATE_BYTE3 == state_reg) & ~flow_is_busy))) begin
        input_read = 1'b1;
    end else begin
        input_read = 1'b0;
    end
end

/// output_write assign process. ///
always @ (state_reg or flow_is_busy)
begin
    if (((STATE_BYTE3 == state_reg) & ~flow_is_busy)) begin
        output_write = 1'b1;
    end else begin
        output_write = 1'b0;
    end
end
always @ (input_empty_n or state_reg or flow_is_busy)
begin
    case (state_reg)
        STATE_INIT : 
				//state_new = state_after_init;
				state_new = STATE_BYTE0;
        STATE_BYTE0 : 
            if (~(input_empty_n == 1'b0)) begin
                state_new = STATE_BYTE1;
            end else begin
                state_new = STATE_BYTE0;
            end
        STATE_BYTE1 : 
            if (~(input_empty_n == 1'b0)) begin
                state_new = STATE_BYTE2;
            end else begin
                state_new = STATE_BYTE1;
            end
        STATE_BYTE2 : 
            if (~(input_empty_n == 1'b0)) begin
                state_new = STATE_BYTE3;
            end else begin
                state_new = STATE_BYTE2;
            end
        STATE_BYTE3 : 
            if (~flow_is_busy) begin
					 //state_new = state_after_init;
					 state_new = STATE_BYTE0;
            end else begin
                state_new = STATE_BYTE3;
            end
        default : 
            state_new = 'bx;
    endcase
end

/// flow_is_busy assign process. ///
always @ (input_empty_n or output_full_n)
begin
    flow_is_busy = ((input_empty_n == 1'b0) | (output_full_n == 1'b0));
end
assign output_data = {{{{buff_byte0}, {buff_byte1}}, {buff_byte2}}, {input_data}};
//assign state_after_init = (is_pcm_n == 1'b1) ? STATE_BYTE0 : STATE_BYTE2;
//assign state_after_init = (is_pcm_n == 1'b1) ? STATE_BYTE0 : STATE_BYTE2;

endmodule //interleave8to32_v2

