

#include <ap_int.h>
#include <ap_utils.h>
#include <hls_stream.h>



#if 0
static bool reset_done=false;
static ap_uint<2> is_init = 1;
static ap_uint<17> r_ptr;
static ap_uint<17> w_ptr;
static ap_uint<17> fifo_counter;

void axi_fifo_sram(hls::stream<ap_uint<8> > &input, hls::stream<ap_uint<8> > &output,
		volatile ap_uint<17> *sram_addr,
		volatile ap_uint<8> *sram_databus,
		volatile bool *sram_databus_t,
		volatile bool *sram_noe,
		volatile bool *sram_nwe,
		volatile bool *empty
		)
{

#pragma HLS INTERFACE ap_none port=sram_addr bundle=SRAM
#pragma HLS INTERFACE ap_none port=sram_databus bundle=SRAM
#pragma HLS INTERFACE ap_none port=sram_databus_t bundle=SRAM
#pragma HLS INTERFACE ap_none port=sram_noe bundle=SRAM
#pragma HLS INTERFACE ap_none port=sram_nwe bundle=SRAM
#pragma HLS INTERFACE ap_none port=empty

#pragma HLS INTERFACE ap_fifo depth=32 port=input
#pragma HLS INTERFACE ap_fifo depth=32 port=output
#pragma HLS RESOURCE variable=input  core=AXIS metadata="-bus_bundle S_AXIS"
#pragma HLS RESOURCE variable=output core=AXIS metadata="-bus_bundle M_AXIS"
#pragma HLS INTERFACE ap_ctrl_none port=return

	ap_uint<8> io_val;
	ap_uint<8> o_val;

	while(1) {
		if(!reset_done) {
			*sram_addr=0x00;
			*sram_databus=0x00;
			*sram_databus_t=false;
			*sram_noe=true;
			*sram_nwe=true;
			reset_done=true;
			*empty=true;
			is_init=1;


			r_ptr = 0;
			w_ptr = 0;
			fifo_counter = 0;
			ap_wait();

		} else if (fifo_counter < 0x1FFFE && !input.empty()) {

			io_val = input.read();
			*sram_addr=w_ptr;
			*sram_databus=io_val;
			*sram_databus_t=false;
			*sram_noe=true;
			*sram_nwe=false;
			ap_wait();
			*sram_nwe=true;
			w_ptr++;
			fifo_counter++;

			if((is_init==1 && fifo_counter >= 0x1FFFE) ||
			   (is_init==2 && fifo_counter >= 0x10000))
				is_init=0;
			ap_wait();
		} else if (fifo_counter > 0 && is_init==0) {
			if(!output.full()) {
				*sram_addr=r_ptr;
				*sram_databus=0x00;
				*sram_databus_t=true;
				*sram_noe=false;
				*sram_nwe=true;
				ap_wait();
				o_val = ((ap_uint<8>) *sram_databus);
				ap_wait();
				*sram_noe=true;
				*sram_databus_t=false;
				//if(output.write_nb(o_val)) {
					r_ptr++;
					fifo_counter--;
				//}
				output.write(o_val);
			}
			*empty=false;
			ap_wait();
		} else if(is_init==0) {
			*empty=true;
			is_init=2; //re-buffer
			ap_wait();
		}
	  }
}
#endif



static bool reset_done=false;
static bool is_init;
static ap_uint<17> r_ptr;
static ap_uint<17> w_ptr;
static ap_uint<17> fifo_counter;

void axi_fifo_sram(hls::stream<ap_uint<8> > &input, hls::stream<ap_uint<8> > &output,
		volatile ap_uint<17> *sram_addr,
		volatile ap_uint<8> *sram_databus,
		volatile bool *sram_databus_t,
		volatile bool *sram_noe,
		volatile bool *sram_nwe
		)
{

#pragma HLS INTERFACE ap_none port=sram_addr bundle=SRAM
#pragma HLS INTERFACE ap_none port=sram_databus bundle=SRAM
#pragma HLS INTERFACE ap_none port=sram_databus_t bundle=SRAM
#pragma HLS INTERFACE ap_none port=sram_noe bundle=SRAM
#pragma HLS INTERFACE ap_none port=sram_nwe bundle=SRAM

#pragma HLS INTERFACE ap_fifo depth=32 port=input
#pragma HLS INTERFACE ap_fifo depth=32 port=output
#pragma HLS RESOURCE variable=input  core=AXIS metadata="-bus_bundle S_AXIS"
#pragma HLS RESOURCE variable=output core=AXIS metadata="-bus_bundle M_AXIS"
#pragma HLS INTERFACE ap_ctrl_none port=return

//#pragma HLS reset variable=reset_done

	ap_uint<8> io_val;
	//ap_uint<8> o_val;

//	while(1) {
		if(!reset_done) {
			*sram_addr=0x00;
			*sram_databus=0x00;
			*sram_databus_t=false;
			*sram_noe=true;
			*sram_nwe=true;
			reset_done=true;
			is_init=true;


			r_ptr = 0;
			w_ptr = 0;
			fifo_counter = 0;
			ap_wait();

		} else if (fifo_counter < 0x1FFFE && !input.empty()) {

			io_val = input.read();
			*sram_addr=w_ptr;
			*sram_databus=io_val;
			*sram_databus_t=false;
			*sram_noe=true;
			*sram_nwe=false;
			ap_wait();
			*sram_nwe=true;
			w_ptr++;
			fifo_counter++;

			if(is_init && fifo_counter >= 0x10000)
				is_init=false;
			ap_wait();
		} else if (fifo_counter > 0 && !is_init) {
			if(!output.full()) {
				*sram_addr=r_ptr;
				*sram_databus=0x00;
				*sram_databus_t=true;
				*sram_noe=false;
				*sram_nwe=true;
				ap_wait();
				io_val = ((ap_uint<8>) *sram_databus);
				ap_wait();
				*sram_noe=true;
				*sram_databus_t=false;
				r_ptr++;
				fifo_counter--;
				output.write(io_val);
			}
			ap_wait();
		} else if(!is_init) {
			is_init=true; //re-buffer
			ap_wait();
		}
//	  }
}
