// ==============================================================
// RTL generated by Vivado(TM) HLS - High-Level Synthesis from C, C++ and SystemC
// Version: 2014.1
// Copyright (C) 2014 Xilinx Inc. All rights reserved.
// 
// ===========================================================

`timescale 1 ns / 1 ps 

(* CORE_GENERATION_INFO="interleave8to32,hls_ip_2014_1,{HLS_INPUT_TYPE=cxx,HLS_INPUT_FLOAT=0,HLS_INPUT_FIXED=1,HLS_INPUT_PART=xc6slx9tqg144-2,HLS_INPUT_CLOCK=10.000000,HLS_INPUT_ARCH=others,HLS_SYN_CLOCK=0.000000,HLS_SYN_LAT=-1,HLS_SYN_TPT=none,HLS_SYN_MEM=0,HLS_SYN_DSP=0,HLS_SYN_FF=0,HLS_SYN_LUT=0}" *)

module interleave8to32 (
        ap_clk,
        ap_rst,
        input_V_V_dout,
        input_V_V_empty_n,
        input_V_V_read,
        output_V_V_din,
        output_V_V_full_n,
        output_V_V_write
);

parameter    ap_const_logic_1 = 1'b1;
parameter    ap_const_logic_0 = 1'b0;
parameter    ap_ST_st1_fsm_0 = 3'b000;
parameter    ap_ST_st2_fsm_1 = 3'b1;
parameter    ap_ST_st3_fsm_2 = 3'b10;
parameter    ap_ST_st4_fsm_3 = 3'b11;
parameter    ap_ST_st5_fsm_4 = 3'b100;
parameter    ap_true = 1'b1;

input   ap_clk;
input   ap_rst;
input  [7:0] input_V_V_dout;
input   input_V_V_empty_n;
output   input_V_V_read;
output  [31:0] output_V_V_din;
input   output_V_V_full_n;
output   output_V_V_write;

reg input_V_V_read;
reg output_V_V_write;
reg   [7:0] tmp_V_reg_60;
reg   [2:0] ap_CS_fsm = 3'b000;
reg   [7:0] tmp_V_1_reg_65;
reg   [7:0] tmp_V_2_reg_70;
reg    ap_sig_bdd_39;
reg   [2:0] ap_NS_fsm;




/// the current state (ap_CS_fsm) of the state machine. ///
always @ (posedge ap_clk)
begin : ap_ret_ap_CS_fsm
    if (ap_rst == 1'b1) begin
        ap_CS_fsm <= ap_ST_st1_fsm_0;
    end else begin
        ap_CS_fsm <= ap_NS_fsm;
    end
end

/// assign process. ///
always @(posedge ap_clk)
begin
    if ((~(input_V_V_empty_n == ap_const_logic_0) & (ap_ST_st3_fsm_2 == ap_CS_fsm))) begin
        tmp_V_1_reg_65 <= input_V_V_dout;
    end
end

/// assign process. ///
always @(posedge ap_clk)
begin
    if ((~(input_V_V_empty_n == ap_const_logic_0) & (ap_ST_st4_fsm_3 == ap_CS_fsm))) begin
        tmp_V_2_reg_70 <= input_V_V_dout;
    end
end

/// assign process. ///
always @(posedge ap_clk)
begin
    if (((ap_ST_st2_fsm_1 == ap_CS_fsm) & ~(input_V_V_empty_n == ap_const_logic_0))) begin
        tmp_V_reg_60 <= input_V_V_dout;
    end
end

/// input_V_V_read assign process. ///
always @ (input_V_V_empty_n or ap_CS_fsm or ap_sig_bdd_39)
begin
    if ((((ap_ST_st2_fsm_1 == ap_CS_fsm) & ~(input_V_V_empty_n == ap_const_logic_0)) | (~(input_V_V_empty_n == ap_const_logic_0) & (ap_ST_st3_fsm_2 == ap_CS_fsm)) | (~(input_V_V_empty_n == ap_const_logic_0) & (ap_ST_st4_fsm_3 == ap_CS_fsm)) | ((ap_ST_st5_fsm_4 == ap_CS_fsm) & ~ap_sig_bdd_39))) begin
        input_V_V_read = ap_const_logic_1;
    end else begin
        input_V_V_read = ap_const_logic_0;
    end
end

/// output_V_V_write assign process. ///
always @ (ap_CS_fsm or ap_sig_bdd_39)
begin
    if (((ap_ST_st5_fsm_4 == ap_CS_fsm) & ~ap_sig_bdd_39)) begin
        output_V_V_write = ap_const_logic_1;
    end else begin
        output_V_V_write = ap_const_logic_0;
    end
end
always @ (input_V_V_empty_n or ap_CS_fsm or ap_sig_bdd_39)
begin
    case (ap_CS_fsm)
        ap_ST_st1_fsm_0 : 
            ap_NS_fsm = ap_ST_st2_fsm_1;
        ap_ST_st2_fsm_1 : 
            if (~(input_V_V_empty_n == ap_const_logic_0)) begin
                ap_NS_fsm = ap_ST_st3_fsm_2;
            end else begin
                ap_NS_fsm = ap_ST_st2_fsm_1;
            end
        ap_ST_st3_fsm_2 : 
            if (~(input_V_V_empty_n == ap_const_logic_0)) begin
                ap_NS_fsm = ap_ST_st4_fsm_3;
            end else begin
                ap_NS_fsm = ap_ST_st3_fsm_2;
            end
        ap_ST_st4_fsm_3 : 
            if (~(input_V_V_empty_n == ap_const_logic_0)) begin
                ap_NS_fsm = ap_ST_st5_fsm_4;
            end else begin
                ap_NS_fsm = ap_ST_st4_fsm_3;
            end
        ap_ST_st5_fsm_4 : 
            if (~ap_sig_bdd_39) begin
                ap_NS_fsm = ap_ST_st2_fsm_1;
            end else begin
                ap_NS_fsm = ap_ST_st5_fsm_4;
            end
        default : 
            ap_NS_fsm = 'bx;
    endcase
end

/// ap_sig_bdd_39 assign process. ///
always @ (input_V_V_empty_n or output_V_V_full_n)
begin
    ap_sig_bdd_39 = ((input_V_V_empty_n == ap_const_logic_0) | (output_V_V_full_n == ap_const_logic_0));
end
assign output_V_V_din = {{{{tmp_V_reg_60}, {tmp_V_1_reg_65}}, {tmp_V_2_reg_70}}, {input_V_V_dout}};


endmodule //interleave8to32

