

#include <ap_int.h>
#include <ap_utils.h>
#include <hls_stream.h>


//static ap_uint<32> buff4 = 0x00;

enum {
	DEST_NONE=0x00,
	DEST_PS,
	DEST_RT,
};

typedef struct {
	ap_uint<8> data;
	ap_uint<1> last;
} u8stream;


//icy-metaint:16000

//static const ap_uint<8> icy_metaint[12] = "icy-metaint:";
static const ap_uint<8> icy_metaint[12] = {'i', 'c', 'y', '-', 'm', 'e', 't', 'a', 'i', 'n', 't', ':'};
//icy-name:
static const ap_uint<8> icy_name[9] = {'i', 'c', 'y', '-', 'n', 'a', 'm', 'e', ':'};

enum {
	HTTP_HEADER_LINE = 0x00,
	HTTP_DATA_MP3,
	HTTP_DATA_META_HDR,
	HTTP_DATA_META_DATA
};
#if 0
static ap_uint<2> state = HTTP_HEADER_LINE;
static ap_uint<18> metadata_interval = 0;
static ap_uint<18> mp3_sent = 0;
static ap_uint<8> line_len = 0x00;
static ap_uint<12> md_len = 0x00;
static ap_uint<12> md_pos = 0x00;



//void feed_metadata(ap_uint<8> val)
//{
//#pragma HLS inline
//
//}

static ap_uint<4> meta_match_len = 0x00;
static ap_uint<4> name_match_len = 0x00;
//static ap_uint<10> ps_pos_tab[8] = {8,9,14,15,20,21,26,27};
static ap_uint<3> ps_pos = 0;
static bool last_sent;

//ap_uint<10> getPos(ap_uint<8> pos){
//#pragma HLS inline
//	ap_uint<10> val = 8 + 6 * (pos >> 1) + pos & 0x01;
//	return val;
//}

static ap_uint<16> val2 = 0x0000;
#endif


static ap_uint<18> metadata_interval = 0;
static ap_uint<18> mp3_sent;
static ap_uint<8> line_len;
static ap_uint<12> md_len;
static ap_uint<12> md_pos;

static ap_uint<4> meta_match_len;
static ap_uint<4> name_match_len;
static bool last_sent;
static ap_uint<16> val2;
static ap_uint<2> state;



void mp3_metadata(
		hls::stream<ap_uint<8> >   &input,
		hls::stream<ap_uint<8> >   &output,
		hls::stream<u8stream >   &rds
//		ap_uint<8> rds_ram[1024]
)
{
#pragma HLS ARRAY_PARTITION variable=icy_metaint complete dim=1
#pragma HLS ARRAY_PARTITION variable=icy_name complete dim=1
//#pragma HLS ARRAY_PARTITION variable=ps_pos_tab complete dim=1

#pragma HLS INTERFACE ap_fifo port=rds
#pragma HLS INTERFACE ap_fifo port=input
#pragma HLS INTERFACE ap_fifo port=output
#pragma HLS RESOURCE variable=rds core=AXIS metadata="-bus_bundle RDS_AXIS"
#pragma HLS RESOURCE variable=input core=AXIS metadata="-bus_bundle S_AXIS"
#pragma HLS RESOURCE variable=output core=AXIS metadata="-bus_bundle M_AXIS"

//#pragma HLS INTERFACE ap_memory port=rds_ram
//#pragma HLS RESOURCE variable=rds_ram core=RAM_1P_BRAM

#pragma HLS INTERFACE ap_ctrl_none port=return

	/*
#=== Resource usage ===
SLICE:           81
LUT:            269
FF:              86
DSP:              0
BRAM:             0
SRL:              0
#=== Final timing ===
CP required:    10.000
CP achieved:    7.397
	 * */

	//with reset logic:
//#pragma HLS reset variable=state
/*
#=== Resource usage ===
SLICE:           81
LUT:            269
FF:              86
DSP:              0
BRAM:             0
SRL:              0
 * */


//#pragma HLS reset variable=state
//#pragma HLS reset variable=line_len
//#pragma HLS reset variable=meta_match_len
//#pragma HLS reset variable=name_match_len

//	u8stream rds;

	state = HTTP_HEADER_LINE;
	metadata_interval = 0;
	line_len=0;
	mp3_sent=0;

while(1) {

	ap_uint<8> val = input.read();
	val2 = val2 << 8 | val;
//	ap_wait();
	switch(state) {

	case HTTP_HEADER_LINE: {
		if(val2==0x0d0a) {
			if(line_len<=1) { //0x0d has been counted
				state=HTTP_DATA_MP3;
			}
			line_len=0x00;
			meta_match_len=0x00;
			name_match_len=0x00;
			//reset positions
//			u8stream rds_val;
//			rds_val.data=DEST_NONE;
///			rds_val.last=1;

			rds.write((const u8stream) {DEST_NONE,1});
		} else {

			/*****************************************************************
			 * FEED HEADER
			 *****************************************************************/
			if(line_len < 12 && val == icy_metaint[line_len]) {
				meta_match_len++;
				//if(line_len == 11) metadata_interval = 0;
			} else if(meta_match_len==12 && val >= 0x30 && val <= 0x39) {
				metadata_interval = metadata_interval * 10 + (val-0x30);
//#ifndef  __SYNTHESIS__
//				fprintf(stderr, "[HARD] metadata_interval=%d\n", (uint32_t)metadata_interval);
//#endif
			}

#if 1
/*
#=== Resource usage ===
SLICE:           78
LUT:            256
FF:              87
DSP:              0
BRAM:             0
SRL:              0
 * */
			if(line_len < 9 && val == icy_name[line_len]) {
				name_match_len++;
				if(name_match_len==9) {
#if 1
					//u8stream rds_val;
					//rds_val.data=DEST_PS;
					//rds_val.last=0;
					//rds.write(rds_val);

					rds.write((const u8stream) {DEST_PS,0});
#endif
				}
			} else if(name_match_len==9) {
//#ifndef  __SYNTHESIS__
#if 1
				//u8stream rds_val;
				//rds_val.data=val;
				//rds_val.last= (val==0x0d) ? 1 : 0;
				//rds.write(rds_val);

				rds.write((const u8stream) {val,(val==0x0d) ? 1 : 0});
#endif
//					fprintf(stderr, "[HARD] STATION:", (char)val);
//				if(val >= 0x20 && val < 0x7F)
//					fprintf(stderr, "%c", (char)val);
//				if(line_len==16 || val == 0x0d)
//					fprintf(stderr, "\n");
//#endif
			}
#endif

#if 0
			u8stream rds_val;
			rds_val.last= (val==0x0d) ? 1 : 0;
			rds_val.data= (name_match_len == 8) ? DEST_PS : val;
			if(line_len < 9 && val == icy_name[line_len]) name_match_len++;
			if(name_match_len==9) rds.write(rds_val);
#endif


			/*****************************************************************
			 * END OF FEED HEADER
			 *****************************************************************/
			line_len++;
		}
		ap_wait();
		break;
	}
	case HTTP_DATA_MP3: {
		output.write(val);
		mp3_sent++;
		if(metadata_interval > 0 && mp3_sent==metadata_interval) {
			state=HTTP_DATA_META_HDR;
			mp3_sent=0;
		}
		ap_wait();
		break;
	}
	case HTTP_DATA_META_HDR: {
		md_len = ((ap_uint<12>) val) << 4;
		md_pos=0;
		last_sent = (md_len > 16) ? false : true;
		state = md_len > 0 ? HTTP_DATA_META_DATA : HTTP_DATA_MP3;
//#ifndef  __SYNTHESIS__
//		fprintf(stderr, "[HARD] md_len=%d: %s", (uint32_t)md_len, md_len ? "" : "\n");
//#endif
		ap_wait();
		break;
	}

	case HTTP_DATA_META_DATA: {
#if 1
		if(!last_sent && (md_pos==0 || md_pos > 12)) {
			//u8stream rds_data;

			//last_sent=(md_pos!=0 && (val == '\'' || md_len==1)) ? true : false;
			last_sent=(md_pos!=0 && (val == 0x3B || md_len==1)) ? true : false;
			//rds_data.last=last_sent;
			//rds_data.data= (md_pos==0) ? DEST_RT : val;
			//rds.write(rds_data);

			rds.write((const u8stream) {(md_pos==0) ? DEST_RT : val,last_sent});
		}
#endif
		md_len--;
		md_pos++;
		if(md_len==0) state=HTTP_DATA_MP3;
		ap_wait();
		break;
	}

	}

//	ap_wait();
  }

}
