
#include <ap_int.h>
#include <ap_utils.h>
#include <hls_stream.h>

//12-33-12
//11-37-12

void rds_enforcer(
		hls::stream<ap_int<15> > &dds_in, hls::stream<ap_int<15> > &dds_out,
		hls::stream<ap_uint<1> > &in_rds, hls::stream<ap_int<2> > &out_rds)
{
#pragma HLS INTERFACE ap_fifo port=dds_in
#pragma HLS INTERFACE ap_fifo port=dds_out
#pragma HLS INTERFACE ap_fifo port=in_rds
#pragma HLS INTERFACE ap_fifo port=out_rds
#pragma HLS RESOURCE variable=dds_in core=AXIS metadata="-bus_bundle S_AXIS"
#pragma HLS RESOURCE variable=dds_out core=AXIS metadata="-bus_bundle M_AXIS"
#pragma HLS RESOURCE variable=in_rds core=AXIS metadata="-bus_bundle S_RDS_AXIS"
#pragma HLS RESOURCE variable=out_rds core=AXIS metadata="-bus_bundle M_RDS_AXIS"
#pragma HLS INTERFACE ap_ctrl_none port=return

	ap_uint<2> idx = 0;
	ap_int<15> dds_val;

	ap_uint<5> khz19_zero_cross = 0;
	ap_uint<1> khz19_phase = 0;
	ap_uint<1> khz19_phase_last = 0;
	ap_int<2> rds_current = 1; //1 or -1

	ap_uint<1> cur_bit, prev_output, cur_output=0;

	while(1) {
		dds_val=dds_in.read(); // dds: 19, 38, 57 khz, lock to 19khz
		dds_out.write(dds_val);
		if(idx==0) {
			khz19_phase = (dds_val > 0) ? 1 : 0;
			if(khz19_phase != khz19_phase_last) {
				khz19_phase_last = khz19_phase;
				khz19_zero_cross++;
				if(khz19_zero_cross == 0) {
					//need to get next bit...
					cur_bit=in_rds.read();

		            prev_output = cur_output;
		            cur_output = prev_output ^ cur_bit;

		            //first half symbol: -1->1 for 1, 1->-1 for 0
		            rds_current = (cur_output == 1) ? -1 : 1; //inverting??
				} else if(khz19_zero_cross == 16) {
					//second half symbol: -1->1 or 1->-1
					rds_current = -1 * rds_current;
				}
			}
			out_rds.write(rds_current);
		}
		idx++;
		if(idx>2) idx=0;
	}
}
