

#include <ap_int.h>
#include <ap_utils.h>
#include <hls_stream.h>



const ap_uint<8> rds_buff_golden[13*9] = {
0xD3, 0x93, 0x46, 0x41, 0x72, 0x16, 0xE1, 0x79, 0x43, 0xED, 0x5D, 0x11, 0x26,//<-> ӓFAr^V.yC.]^Q&
0xD3, 0x93, 0x46, 0x41, 0x72, 0x4D, 0x71, 0x79, 0x43, 0xED, 0x48, 0x83, 0x27,//<-> ӓFArMqyC.H.'
0xD3, 0x93, 0x46, 0x41, 0x72, 0xA1, 0xC1, 0x79, 0x43, 0xEC, 0xCC, 0x82, 0xB3,//<-> ӓFAr..yC. ̂.
0xD3, 0x93, 0x46, 0x41, 0x73, 0xCF, 0x81, 0x79, 0x43, 0xEC, 0x80, 0x80, 0xDC,//<-> ӓFAsρyC쀀.
0xD3, 0x93, 0x46, 0x4D, 0x74, 0x17, 0x60, 0x06, 0x6E, 0xDF, 0x35, 0x1B, 0xC9,//<-> ӓFMt^W`^Fn.5^[.
0xD3, 0x93, 0x46, 0x4D, 0x74, 0x17, 0x66, 0x28, 0x07, 0xDB, 0x35, 0x1B, 0xC9,//<-> ӓFMt^Wf(^G.5^[.
0xD3, 0x93, 0x46, 0x51, 0x70, 0x53, 0x3C, 0x10, 0x6C, 0x2E, 0xE4, 0x1A, 0xCD,//<-> ӓFQpS<^Pl..^Z.
0xD3, 0x93, 0x46, 0x61, 0x72, 0xFD, 0x29, 0x53, 0xC2, 0x78, 0xAC, 0x3E, 0xB3,//<-> ӓFar.)S.x.>.
0xD3, 0x93, 0x46, 0x6D, 0x72, 0x1B, 0xD2, 0x03, 0x82, 0xF1, 0x11, 0x5B, 0x84,//<-> ӓFmr^[.^C..^Q[.
};

ap_uint<8> rds_data[1024] = {
/*
 * [PI], [PI], [NUM_PKTS], [NUM_FIFO]
 * [B1], [B2], [C1], [C2], [D1], [D2], //RDS Packet 1
 * [B1], [B2], [C1], [C2], [D1], [D2], //RDS Packet 2
 * [...]
 *
 * */
0xD3, 0x93, 0x09, 0x00,
0x05, 0xC8, 0x17, 0x94, 0x57, 0x44,
0x05, 0xC9, 0x17, 0x94, 0x52, 0x20,
0x05, 0xCA, 0x17, 0x94, 0x33, 0x20,
0x05, 0xCF, 0x17, 0x94, 0x20, 0x20,
0x35, 0xD0, 0x00, 0x66, 0xCD, 0x46,
0x35, 0xD0, 0x62, 0x80, 0xCD, 0x46,
0x45, 0xC1, 0xC1, 0x06, 0xB9, 0x06,
0x85, 0xCB, 0x95, 0x3C, 0x2B, 0x0F,
0xB5, 0xC8, 0x20, 0x38, 0x44, 0x56
};

void rds_src(ap_uint<8> rds_buff[1024], hls::stream<ap_uint<1> > &output);


int main()
{
    int not_ok = 0;

    hls::stream<ap_uint<1> > data_out;

    int i=0;
    int bit_idx=8;
    int byte_idx=0;
    ap_uint<8> byte_val = 0;
    fprintf(stderr,"Started...\n");
  do {
	// Fill HW buffers
	  rds_src(rds_data, data_out);
	  while(!data_out.empty()) {
		  bit_idx--;
		  i++;
		  ap_uint<1> var = data_out.read();
		  byte_val.set_bit(bit_idx, var);
		  if(bit_idx==0) {
			  fprintf(stderr,"0x%02x, ", (int) byte_val);
			  if(byte_val != rds_buff_golden[byte_idx]) {
				  fprintf(stderr,"[%d]: 0x%02x != 0x%02x\n", byte_idx, (int) byte_val, (int) rds_buff_golden[byte_idx]);
				  not_ok++;
			  }
			  byte_idx++;
			  byte_val = 0;
			  bit_idx=8;
		  }

		  if( i % 104*8 == 0) fprintf(stderr,"\n");
	  }

  } while (byte_idx < 13*9);

  return not_ok;
}
