
#include <ap_int.h>
#include <ap_utils.h>
#include <hls_stream.h>

static ap_int<16> left_prev = 0;
static ap_int<16> right_prev = 0;

static ap_uint<6> adding_count=0;
static ap_uint<4> frame_count=0;

void resample(
		hls::stream<ap_int<16> >   &input,
		hls::stream<ap_int<16> >   &output,
		volatile ap_uint<2> *sample_rate
		)
{

#pragma HLS INTERFACE ap_fifo port=input
#pragma HLS INTERFACE ap_fifo port=output
#pragma HLS RESOURCE variable=input core=AXIS metadata="-bus_bundle S_AXIS"
#pragma HLS RESOURCE variable=output core=AXIS metadata="-bus_bundle M_AXIS"

#pragma HLS INTERFACE ap_none port=sample_rate

#pragma HLS INTERFACE ap_ctrl_none port=return

  ap_int<16> left;
  ap_int<16> right;
//    while(1) {

//	  if(*valid_frame == true) {
	  if(!input.empty()) {
		  left=input.read();
		  right=input.read();
	  } else {
		  left=0;
		  right=0;
		  ap_wait();
	  }

		  left_prev += left / 2 ;
		  right_prev += right / 2 ;
		  //ap_uint<2> rate = (ap_uint<2> ) *sample_rate;


		  if((ap_uint<2> ) (*sample_rate) == 0) { //44100
			  //13 frames per 160
			  //: 1/12 - 13/160 = 1/480
			  //: 40/480 - 1/480 = 39/480
			  //add 1 sample per 12 samples
			  //DO NOT add 1 sample per 160 samples
			  //not_add_interval=480;
			  //if(frame_count>=12) {
			  if(frame_count>=11) {
				  frame_count=0;
				  adding_count++;
				  //if(adding_count>=40) {
				  if(adding_count>=39) {
					  adding_count=0;
				  } else {
					  output.write(left_prev);
					  output.write(right_prev);
				  }
			  }

		  } else if((ap_uint<2> ) (*sample_rate) ==  0b10) { //32000
			  //(48000 − 32000) / 48000 = 1/3
			  //add_interval=3;
			  if(frame_count>=2) {
				  frame_count=0;
				  output.write(left_prev);
				  output.write(right_prev);
			  }
//		  } else if(sample_rate == 1) { //48000
//			  not_add_interval=0;
//			  add_interval=0;
//		  } else { //11 - reserved
//			  not_add_interval=0;
//			  add_interval=0;
		  }
//	  } else {
//		  left=0;
//		  right=0;
//	  }

	  output.write(left);
	  output.write(right);
	  frame_count++;

	  left_prev=left/2;
	  right_prev=right/2;
//  }
}
