
#include <ap_int.h>
#include <ap_utils.h>
#include <hls_stream.h>

#define DISABLE_GAIN
//#undef DISABLE_GAIN

//#define GAIN_CONTROL_MORE_RAM
//#define GAIN_CONTROL_PACKED

void stereo_mpx(hls::stream<ap_int<17> > &input,
		hls::stream<ap_int<15> > &dds,
//		hls::stream<ap_int<16> > &dds38,
//		hls::stream<ap_int<16> > &rds57,
		hls::stream<ap_int<8> > &rds,
		hls::stream<ap_int<20> > &output
		)
{

#pragma HLS INTERFACE ap_fifo port=input
#pragma HLS INTERFACE ap_fifo port=dds
#pragma HLS INTERFACE ap_fifo port=rds
//#pragma HLS INTERFACE ap_fifo port=dds38
#pragma HLS INTERFACE ap_fifo port=output
#pragma HLS RESOURCE variable=dds  core=AXIS metadata="-bus_bundle S_DDS_AXIS"
#pragma HLS RESOURCE variable=rds  core=AXIS metadata="-bus_bundle S_RDS_AXIS"
//#pragma HLS RESOURCE variable=dds38  core=AXIS metadata="-bus_bundle S_DDS38_AXIS"
#pragma HLS RESOURCE variable=input  core=AXIS metadata="-bus_bundle S_AXIS"
#pragma HLS RESOURCE variable=output core=AXIS metadata="-bus_bundle M_AXIS"
#pragma HLS INTERFACE ap_ctrl_none port=return
#if 0
	//########################################################################
	// SHABLON!!!
	//########################################################################

	ap_int<17> lch, rch;
	ap_int<18> sum, diff;
	ap_int<16> khz19, khz38;
	ap_int<23> tmp2;
	ap_int<32> mpx;
	ap_int<20> out;
	while(1) {
		lch=input.read(); //17bit
		rch=input.read(); //17bit
		khz19 = dds19.read(); // 9%
		khz38 = dds38.read() / 256; // 8 bit
		diff=(lch-rch) / 8; //18bit - 3 = 15bit
		tmp2=(diff * khz38); //15bit x 8bit = 23bit
		mpx = ((lch+rch) * 16 ) * 112 + (khz19 * 16)* 24 + (tmp2) * 112; //(<< 4 and x7)
		out = mpx / 256;
		output.write(out);
	}
#endif



#ifdef __WORKS_FINE_V2
	ap_int<17> lch, rch;
	ap_int<18> sum, diff;
	ap_int<16> khz19, khz38;
	ap_int<23> tmp2;
	ap_int<32> mpx;
	ap_int<20> out;

	while(1) {
		lch=input.read(); //17bit
		rch=input.read(); //17bit
		khz19 = dds19.read(); // 9%
		khz38 = dds38.read() / 256; // 8 bit
		//     24/256=>9,375%            112/256 => 43,75%
		//mpx = ((khz19 * 24) + (sum + diff * khz38) * 112) >> 8;
		//mpx = (khz19 * 24 + (lch+rch + (((lch-rch) * khz38) >> 15)) * 112) >> 8;
		//mpx = khz19 * 24 + (lch+rch + (((lch-rch) * khz38) >> 15)) * 112;
		//mpx = khz19 * 24 + (lch+rch + (((lch-rch) * khz38) >> 15)) * 112;

		diff=(lch-rch) / 8; //18bit - 3 = 15bit
		tmp2=(diff * khz38); //15bit x 8bit = 23bit
		//mpx = ((lch+rch) >> 1) * 112 + khz19 * 24 + ((tmp2>>16) >> 1) * 112;


		//       18bit + 4 = 22bit    +    16bit + 6 = 22bit  + 23bit
		//====================================== THE BEST ======================================
		//mpx = ((lch+rch) * 16 + tmp2) * 112 + khz19 * 6 * 16; //(<< 4 and x7)
		//out = mpx / 128;
		//=================================== END OF THE BEST ==================================
		//mpx = ((lch+rch) * 16 + tmp2) * 7 + khz19 * 7; //(<< 4 and x7)

		// GOOD ENOUGHT!!!
		//mpx = ((lch+rch) * 16 + tmp2 + khz19) * 7; //(<< 4 and x7)
		//out = mpx / 8;


		//the simplest
		mpx = ((lch+rch) * 16 + tmp2 + khz19); //(<< 4 and x7)
		//out = mpx / 8;

		/* CLIPPING */
		if(mpx > 200000) mpx = 200000;
		if(mpx < -200000) mpx = -200000;
		//wideness: 22+22 = 23
		//wideness: 23+23 = 24
		//wideness: 23 >> 3 = 20 bit as result

		//tmp2 will be 23 bit
		//lch+rch 18bit << 4 = 22bit
		//khz19 << 16 + 2 = 18bit
//		mpx = ((khz19 << (4+1+1)) * 24 + (tmp2 + ((lch+rch) << 4)) * 112) / 256;



		//mpx = ((lch+rch) >> 1) * 112 * 2 + khz19 * 24;// + khz38;
		//tmp<=((mpx_chanA+mpx_chanB)*$signed(45)+mpx_pilot*$signed(9)+$signed(tmp2>>>15)*$signed(45))/$signed(100);^M
		//(+((mpx_chanA-mpx_chanB)*mpx_subcarrier*45)>>>15+mpx_pilot*9)/100;^M

//		output.write(mpx);
		output.write(mpx);
	};
#endif

#if 0
	ap_int<17> lch, rch;
	ap_int<18> sum, diff;
	ap_int<16> khz19, khz38;
	ap_int<24> tmp2;
	ap_int<32> mpx;

	while(1) {
		lch=input.read(); //17bit
		rch=input.read(); //17bit
		khz19 = dds19.read(); // 9%
		khz38 = dds38.read() / 256; // 8 bit

		//diff=(lch-rch) / 8; //18bit - 3 = 15bit
		diff=(lch-rch) / 8; //18bit - 2 = 16bit
		tmp2=(diff * khz38); //16bit x 8bit = 24bit

		//the simplest
		mpx = (((lch+rch) * 16 + tmp2) * 10 + khz19 * 7) / 8; //(<< 4 and x7)

		/* CLIPPING */
		if(mpx > 200000) mpx = 200000;
		if(mpx < -200000) mpx = -200000;

		output.write(mpx);
	};
#endif

#if 0
	ap_int<18> lch, rch;
	ap_int<19> diff;
	ap_int<16> khz19, khz38, khz57;
	ap_int<25> tmp2;
	ap_int<32> mpx;

	ap_int<1> rds_current = 1; //11 = -1, 01 = 1, 00 = 0
	ap_uint<4> khz19_zero_cross = 0;
	ap_uint<1> khz19_phase = 0;
	ap_uint<1> khz19_phase_last = 0;

	while(1) {
		lch=input.read(); //17bit
		rch=input.read(); //17bit
		khz19 = dds.read(); // 9%
		khz38 = dds.read() / 256; // 8 bit
		khz57 = dds.read() / 256; // 8 bit
//		if(!rds57.empty())
//			khz57 = rds57.read();
//		else

		khz19_phase = (khz19 > 0) ? 1 : 0;
		if(khz19_phase != khz19_phase_last) {
			khz19_phase_last = khz19_phase;
			khz19_zero_cross++;
			if(khz19_zero_cross == 0) {
				rds_current = rds.read();
			}
		}

		diff=(lch-rch) / 8; //19bit - 3 = 16bit
		tmp2=(diff * khz38); //16bit x 8bit = 24bit

		//the simplest
		mpx = (((lch+rch) * 16 + tmp2) * 7 + (khz19 + khz57 * fir2khz(rds_current ? 1 : -1) ) * 7 * 2) / 16; //(<< 4 and x7)

		/* CLIPPING */
//		if(mpx > 200000) mpx = 200000;
//		if(mpx < -200000) mpx = -200000;

		output.write(mpx);
	};
#endif



#if 0 //FINAL OUTPUT
	ap_int<17> lch, rch;
	ap_int<18> diff;
	ap_int<16> khz19, khz38, khz57;
	ap_int<26> tmp2;
	ap_int<32> mpx;
	ap_int<8> rds_sample = 0;

	while(1) {
		lch=input.read(); //17bit
		rch=input.read(); //17bit
		khz19 = dds.read(); // 9%
//		khz38 = dds.read() / 128; // 9 bit
		khz38 = dds.read() / 256; // 9 bit
//		khz57 = dds.read() / 64; // 10 bit
		khz57 = dds.read() / 32; // 10 bit
//		if(!rds.empty()) //prevent locking due RDS FIR delay
			rds_sample = rds.read();
//		khz57 = dds.read() / 64 * rds.read();
//		khz57 = khz57 - khz57/2;

		diff=(lch - rch) / 8; //17bit - 3 + 1 = 15bit
		tmp2=(diff * khz38); //15bit x 9bit = 24bit

		//the simplest
		//MELODIA:
/*
#=== Resource usage ===
SLICE:          109
LUT:            298
FF:             262
DSP:              2
BRAM:             0
SRL:              0*/
		//mpx = ((lch+rch) * 256 + tmp2 * 7 + (khz19 * 8 + khz57 * rds_sample * 12) * 2) / 16; //(<< 4 and x7)



/*
#=== Resource usage ===
SLICE:          101
LUT:            274
FF:             225
DSP:              2
BRAM:             0
SRL:              0

#=== Resource usage ===
SLICE:           95
LUT:            277
FF:             177
DSP:              2
BRAM:             0
SRL:              0
 * */
//		mpx = ((lch+rch) * 256 + tmp2 * 6 + (khz19 * 8 + khz57 * rds_sample * 12) * 2) / 16; //(<< 4 and x7)


/*
#=== Resource usage ===
SLICE:          101
LUT:            274
FF:             225
DSP:              2
BRAM:             0
SRL:              0
 * */
//		mpx = (((lch+rch) * 32 + tmp2) * 6 + (khz19 * 8 + khz57 * rds_sample * 12) * 2) / 16; //(<< 4 and x7)

/*
#=== Resource usage ===
SLICE:          100
LUT:            283
FF:             171
DSP:              2
BRAM:             0
SRL:              0
 * */

//		mpx = (((lch+rch) * 256 + tmp2 * 2) * 1 + (khz19 * 12 + khz57 * rds_sample * 16) * 1) / 16; //(<< 4 and x7)
		//ORIGINAL:
/*
#=== Resource usage ===
SLICE:           85
LUT:            263
FF:             214
DSP:              2
BRAM:             0
SRL:              0
*/
//		mpx = (((lch+rch) * 32 + tmp2) * 6 + (khz19 * 8 + khz57 * rds_sample * 12) * 2) / 16; //(<< 4 and x7)
		//mpx = (((lch+rch) * 32 + tmp2) * 6 + (khz19 * 2 + khz57 * rds_sample * 3) * 7) / 16; //(<< 4 and x7)

		//mpx = (((lch+rch) * 32 + tmp2 + khz19 * 2 + khz57 * rds_sample * 3) * 7) / 16; //(<< 4 and x7)
/*
#=== Resource usage ===
SLICE:           89
LUT:            278
FF:             197
DSP:              2
BRAM:             0
SRL:              0
*/



		/*
		 *
#=== Resource usage ===
SLICE:           76
LUT:            243
FF:             149
DSP:              2
BRAM:             0
SRL:              0
		 * */

		mpx = (lch+rch) * 16 + tmp2 + khz19 +  khz57 * rds_sample;
		mpx = mpx - mpx/8;

		/* CLIPPING */
//		if(mpx > 262143) mpx = 262143;
//		else if(mpx < -262144) mpx = -262144;

		output.write(mpx);
	};
#endif

	ap_int<17> lch, rch;
	ap_int<18> diff;
	ap_int<15> khz19, khz38, khz57;
	ap_int<26> tmp2;
	ap_int<32> mpx;
	ap_int<8> rds_sample = 0;

	while(1) {
		lch=input.read(); //17bit
		rch=input.read(); //17bit
		khz19 = dds.read(); // 9%
//		khz38 = dds.read() / 128; // 9 bit
		khz38 = dds.read() / 128; // 9 bit
//		khz57 = dds.read() / 64; // 10 bit
		khz57 = dds.read() / 16; // 10 bit
//		if(!rds.empty()) //prevent locking due RDS FIR delay
			rds_sample = rds.read();
//		khz57 = dds.read() / 64 * rds.read();
//		khz57 = khz57 - khz57/2;

		diff=(lch - rch) / 8; //17bit - 3 + 1 = 15bit
		tmp2=(diff * khz38); //15bit x 9bit = 24bit

		//76-246-142-2
		//mpx = (lch+rch) * 16 + tmp2 + 2*khz19 +  khz57 * rds_sample;
		//mpx = mpx - mpx/8;

		//66-212-115-2
		mpx = khz57 * rds_sample + khz19*2;
		mpx = mpx - mpx/8;
		mpx = mpx + (lch+rch) * 16 + tmp2;

		/* CLIPPING */
		//if(mpx > 262143) mpx = 262143;
		//else if(mpx < -262144) mpx = -262144;

		output.write(mpx);
	};



}
